--10

--SELECT s.sid, s.sname
--FROM sailors as s, boats as b, reserves as r
--WHERE s.sid=r.sid AND b.bid=r.bid AND 
--	NOT EXISTS ( 	SELECT b2.bid
--					FROM boats as b2
					----WHERE b2.bname='Interlake' AND NOT (
--						NOT EXISTS ( 	SELECT s3.sid
										--FROM sailors as s3
										--WHERE s3.sid=s.sid AND NOT (
----											NOT EXISTS ( 	SELECT b4.bid
															------FROM boats as b4
															--WHERE b4.bname!='Interlake'
														--)
										--)
									--)
					--)
				--);
				
				
--SELECT DISTINCT( s.sid ), s.sname 
--FROM sailors as s, boats as b, reserves as r
--WHERE s.sid=r.sid AND b.bid=r.bid AND (
--						NOT EXISTS (
--							SELECT b2.bid 
--							FROM boats as b2
--							WHERE b2.bid=b.bid AND b2.bname!='Interlake'
--							) OR b.bname='Interlake'
--							)
--						;


SELECT DISTINCT( s.sid ), s.sname 
FROM sailors as s, boats as b, reserves as r, (
	SELECT COUNT( DISTINCT( b2.bid ) ) as bater
	FROM boats as b2
	WHERE b2.bname='Interlake'
	) as sok
WHERE s.sid=r.sid AND b.bid=r.bid AND EXISTS ( 
	SELECT b3.bid
	FROM boats as b3
	WHERE b3.bname='Interlake' AND b3.bid=b.bid
	)
GROUP BY s.sid, s.sname, sok.bater
HAVING COUNT( b.bid ) = sok.bater
;